//
// SCS Client v1.0 beta (1998, December, 10)
//
// Copyright (C) 1998 by Grigori G.Fursin
//

//Import libraries...
import java.io.*;
import java.awt.*;

//Main class
public class SCS_C
{
	//Variables
	static int CfgMaxParam=20;
	static int StrMaxLen=1024;

	static public String AppDir="";
	static public String Sep=""; 
	static public FGGCFG fggcfg=null;

	// *******************************************************************
	public static void main(String args[]) 
	{
		//Logo
		System.out.println("Starting program ...\n");

		//Preparing string ApplicationDirectory & Separator
		try
		{
			AppDir=System.getProperty("user.dir");
			Sep=System.getProperty("file.separator");
		}
		catch(SecurityException se)
		{
			System.out.print("Fatal Error: Can't get system properties\n(");
			System.out.print(se.getMessage());
			System.out.println(")!");
			SCS_C_misc.ask_key();
			System.exit(1);
		}

		if (Sep.charAt(0)!='\\')
		{
			System.out.println("Fatal Error: Can't get file separator from system!");
			SCS_C_misc.ask_key();
			System.exit(1);
		}

		AppDir+=Sep;

		//Constructing triggers
		SCS_C_triggers triggers=new SCS_C_triggers(1);

		//Constructing and loading configuration
		String FileCfg=AppDir+"SCS_C.cfg";

		fggcfg = new FGGCFG(CfgMaxParam, StrMaxLen, FileCfg);
	
		if (fggcfg.Load()!=0) SCS_C_misc.default_cfg(fggcfg, 0);
		SCS_C_misc.check_cfg(fggcfg, 0);

		//Prepare main frame
		SCS_C_frame frame_main=new SCS_C_frame(fggcfg, AppDir, Sep);

		//Set Background color for all windows...
		frame_main.setBackground(Color.lightGray);

		//Show dialog about for some time
		if ("1".equals(fggcfg.Get(4)))
		{
			SCS_C_about frame_about=new SCS_C_about(frame_main, fggcfg, AppDir, Sep, triggers, 1);
			while (!triggers.trigger[1]) 
			{
				try
				{
					Thread.sleep(500);
				}
				catch (InterruptedException e) {}
			}

			frame_about=null;

			System.gc();
			System.runFinalization();
		}

		//Show main frame
		frame_main.show();
	}
}
