//
// Class SCS_C_frame
//                  
// Copyright (C) 1998 by Grigori G.Fursin
//

//Import libraries...
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class SCS_C_frame extends Frame implements ActionListener 
{
	//Variables
	String AppDir;
	String Sep;
	FGGCFG fggcfg=null;
	Image img_ico=null;

	Dimension size;

	String s_m10="File";
	String s_m10_10="New Project";
	String s_m10_20="Open Project";
	String s_m10_30="Save Project";
	String s_m10_40="Save Project As ...";
	String s_m10_50="Close Project";
	String s_m10_60="Exit";

	String s_m20="Project";
	String s_m20_10="Full Start";
	String s_m20_20="Create Directories on SCS Server";
	String s_m20_30="Send Files to SCS Server";
	String s_m20_40="Start 'Compile' Job";
	String s_m20_50="Wait for Completing of 'Compile' Job";
	String s_m20_60="Start 'Run' Job";
	String s_m20_70="Wait for Completing of 'Run' job";
	String s_m20_80="Get Files from SCS Server";

	String s_m30="Options";
	String s_m30_10="Client Options";
	String s_m30_20="Window Options";

	String s_m40="Help";
	String s_m40_10="About Program";

	MenuItem m10_30;
	MenuItem m10_40;
	MenuItem m10_50;
	MenuItem m10_60;

	MenuItem m20_10;
	MenuItem m20_20;
	MenuItem m20_30;
	MenuItem m20_40;
	MenuItem m20_50;
	MenuItem m20_60;
	MenuItem m20_70;
	MenuItem m20_80;

	//Components
	Label comp1a;
	Label comp1b;
	Label comp1c;
	Button comp1d;

	Label comp2a;
	Label comp2b;
	Label comp2c;
	Button comp2d;

	Label comp3aa;
	Button comp3ab;
	Label comp3ba;
	Button comp3bb;

	Label comp4a;
	Label comp4b;
	Label comp4c;
	Label comp4d;

	Label comp5a;
	Label comp5b;
	Label comp5c;
	Label comp5d;
	
	//Component's Strings
	String str1a="Filename of the current project:";
	String str1b="12345678012345678.123123"; //Dummy
	String str1c="Properties of the current project:";
	String str1d="Project Properties...";
	String str2a="Main project directory on SCS Server:";
	String str2c="Add/Delete directories on SCS Server:";
	String str2d="Directories...";
	String str3aa="Add/Delete files to be sent to Server:";
	String str3ab="Files to be sent...";
	String str3ba="Add/Delete files to be received from Server:";
	String str3bb="Files to be received...";
	String str4a="File(s) to compile:";
	String str4c="Name of executable (output) file:";
	String str5a="Connect MPI library to project:";
	String str5c="Number of processors:";

	SCS_C_PRJ prj=null;

	// *******************************************************************
	public SCS_C_frame(FGGCFG xfggcfg, String xAppDir, String xSep)
	{
		super("SCS Client v2.0 beta");

		int dec;

		fggcfg=xfggcfg;
		AppDir=xAppDir;
		Sep=xSep;

		try {dec=Integer.decode(fggcfg.Get(1)).intValue();}
		catch (NumberFormatException nfe1) {dec=0;}
		int cx=dec;

		try {dec=Integer.decode(fggcfg.Get(2)).intValue();}
		catch (NumberFormatException nfe2) {dec=0;}
		int cy=dec;

		setLocation(cx, cy);
		setBounds(cx,cy,400,400);

		setResizable(false);

		//Menu
		MenuBar mb=new MenuBar();

		Menu m10=new Menu(s_m10);
		m10.add(new MenuItem(s_m10_10));
		m10.addSeparator();
		m10.add(new MenuItem(s_m10_20));
			m10_30=new MenuItem(s_m10_30);
		m10.add(m10_30);
			m10_40=new MenuItem(s_m10_40);
		m10.add(m10_40);
			m10_50=new MenuItem(s_m10_50);
		m10.add(m10_50);
		m10.addSeparator();
		m10.add(new MenuItem(s_m10_60));
		m10.addActionListener(this);

		Menu m20=new Menu(s_m20);
			m20_10=new MenuItem(s_m20_10);
		m20.add(m20_10);
		m20.addSeparator();
			m20_20=new MenuItem(s_m20_20);
		m20.add(m20_20);
			m20_30=new MenuItem(s_m20_30);
		m20.add(m20_30);
			m20_40=new MenuItem(s_m20_40);
		m20.add(m20_40);
			m20_50=new MenuItem(s_m20_50);
		m20.add(m20_50);
			m20_60=new MenuItem(s_m20_60);
		m20.add(m20_60);
			m20_70=new MenuItem(s_m20_70);
		m20.add(m20_70);
			m20_80=new MenuItem(s_m20_80);
		m20.add(m20_80);
		m20.addActionListener(this);

		Menu m30=new Menu(s_m30);
		m30.add(new MenuItem(s_m30_10));
		m30.add(new MenuItem(s_m30_20));
		m30.addActionListener(this);

		Menu m90=new Menu(s_m40);
		m90.add(new MenuItem(s_m40_10));
		m90.addActionListener(this);
	
		mb.add(m10);
		mb.add(m20);
		mb.add(m30);
		mb.add(m90);

		setMenuBar(mb);		

		//Drawing main components on frame
		int gap1=10;
		int gap2=2;

		//First panel for border
		Panel p=new Panel();
		FlowLayout fl=new FlowLayout(FlowLayout.LEFT);
		fl.setHgap(gap1);
		fl.setVgap(gap1);

		setLayout(fl);

		add(p);

		GridLayout lt=new GridLayout(5,1);
		lt.setHgap(gap1);
		lt.setVgap(gap1);

		//Layouts
		GridLayout lt1=new GridLayout(2,1);
		lt1.setHgap(gap2);
		lt1.setVgap(gap2);

		FlowLayout lt1a=new FlowLayout(FlowLayout.LEFT);
		lt1a.setHgap(gap2);
		lt1a.setVgap(gap2);
                             
		FlowLayout lt1b=new FlowLayout(FlowLayout.LEFT);
		lt1b.setHgap(gap2);
		lt1b.setVgap(gap2);

		GridLayout lt2=new GridLayout(2,1);
		lt2.setHgap(gap2);
		lt2.setVgap(gap2);

		FlowLayout lt2a=new FlowLayout(FlowLayout.LEFT);
		lt2a.setHgap(gap2);
		lt2a.setVgap(gap2);
                             
		FlowLayout lt2b=new FlowLayout(FlowLayout.LEFT);
		lt2b.setHgap(gap2);
		lt2b.setVgap(gap2);

		GridLayout lt3=new GridLayout(1,2);
		lt3.setHgap(gap1);
		lt3.setVgap(gap1);

		GridLayout lt3a=new GridLayout(2,1);
		lt3a.setHgap(gap2);
		lt3a.setVgap(gap2);

		FlowLayout lt3aa=new FlowLayout(FlowLayout.CENTER);
		lt3aa.setHgap(gap2);
		lt3aa.setVgap(gap2);
                             
		FlowLayout lt3ab=new FlowLayout(FlowLayout.CENTER);
		lt3ab.setHgap(gap2);
		lt3ab.setVgap(gap2);

		GridLayout lt3b=new GridLayout(2,1);
		lt3b.setHgap(gap2);
		lt3b.setVgap(gap2);

		FlowLayout lt3ba=new FlowLayout(FlowLayout.CENTER);
		lt3ba.setHgap(gap2);
		lt3ba.setVgap(gap2);
                             
		FlowLayout lt3bb=new FlowLayout(FlowLayout.CENTER);
		lt3bb.setHgap(gap2);
		lt3bb.setVgap(gap2);

		GridLayout lt4=new GridLayout(2,1);
		lt4.setHgap(gap2);
		lt4.setVgap(gap2);

		FlowLayout lt4a=new FlowLayout(FlowLayout.LEFT);
		lt4a.setHgap(gap2);
		lt4a.setVgap(gap2);
                             
		FlowLayout lt4b=new FlowLayout(FlowLayout.LEFT);
		lt4b.setHgap(gap2);
		lt4b.setVgap(gap2);

		GridLayout lt5=new GridLayout(2,1);
		lt5.setHgap(gap2);
		lt5.setVgap(gap2);

		FlowLayout lt5a=new FlowLayout(FlowLayout.LEFT);
		lt5a.setHgap(gap2);
		lt5a.setVgap(gap2);
                             
		FlowLayout lt5b=new FlowLayout(FlowLayout.LEFT);
		lt5b.setHgap(gap2);
		lt5b.setVgap(gap2);

		//Panels
		SCS_C_FramedArea p1=new SCS_C_FramedArea();
		p1.setLayout(lt1);

		Panel p1a=new Panel();
		p1a.setLayout(lt1a);

		Panel p1b=new Panel();
		p1b.setLayout(lt1a);

		SCS_C_FramedArea p2=new SCS_C_FramedArea();
		p2.setLayout(lt2);

		Panel p2a=new Panel();
		p2a.setLayout(lt2a);

		Panel p2b=new Panel();
		p2b.setLayout(lt2a);

		Panel p3=new Panel();
		p3.setLayout(lt3);

		SCS_C_FramedArea p3a=new SCS_C_FramedArea();
		p3a.setLayout(lt3a);

		Panel p3aa=new Panel();
		p3aa.setLayout(lt3aa);

		Panel p3ab=new Panel();
		p3ab.setLayout(lt3ab);

		SCS_C_FramedArea p3b=new SCS_C_FramedArea();
		p3b.setLayout(lt3b);

		Panel p3ba=new Panel();
		p3ba.setLayout(lt3ba);

		Panel p3bb=new Panel();
		p3bb.setLayout(lt3bb);

		SCS_C_FramedArea p4=new SCS_C_FramedArea();
		p4.setLayout(lt4);

		Panel p4a=new Panel();
		p4a.setLayout(lt4a);

		Panel p4b=new Panel();
		p4b.setLayout(lt4a);

		SCS_C_FramedArea p5=new SCS_C_FramedArea();
		p5.setLayout(lt5);

		Panel p5a=new Panel();
		p5a.setLayout(lt5a);

		Panel p5b=new Panel();
		p5b.setLayout(lt5a);

		//Components
		comp1a=new Label(str2c, Label.LEFT);
		comp1b=new Label(str1b, Label.LEFT);
		comp1c=new Label(str2c, Label.LEFT);
		comp1d=new Button(str1d);
		comp1d.addActionListener(this);

		p1a.add(comp1a);
		p1a.add(comp1b);
		p1b.add(comp1c);
		p1b.add(comp1d);

		comp2a=new Label(str2c, Label.LEFT);
		comp2b=new Label(str1b, Label.LEFT);
		comp2c=new Label(str2c, Label.LEFT);
		comp2d=new Button(str2d);
		comp2d.addActionListener(this);

		p2a.add(comp2a);
		p2a.add(comp2b);
		p2b.add(comp2c);
		p2b.add(comp2d);

		comp3aa=new Label(str3aa, Label.LEFT);
		comp3ab=new Button(str3ab);
		comp3ab.addActionListener(this);
		comp3ba=new Label(str3ba, Label.LEFT);
		comp3bb=new Button(str3bb);
		comp3bb.addActionListener(this);

		p3aa.add(comp3aa);
		p3ab.add(comp3ab);
		p3ba.add(comp3ba);
		p3bb.add(comp3bb);

		comp4a=new Label(str2c, Label.LEFT);
		comp4b=new Label(str1b, Label.LEFT);
		comp4c=new Label(str2c, Label.LEFT);
		comp4d=new Label(str1b, Label.LEFT);

		p4a.add(comp4a);
		p4a.add(comp4b);
		p4b.add(comp4c);
		p4b.add(comp4d);

		comp5a=new Label(str2c, Label.LEFT);
		comp5b=new Label(str1b, Label.LEFT);
		comp5c=new Label(str2c, Label.LEFT);
		comp5d=new Label(str1b, Label.LEFT);

		p5a.add(comp5a);
		p5a.add(comp5b);
		p5b.add(comp5c);
		p5b.add(comp5d);

		p.setLayout(lt);
		p.add(p1);
		p1.add(p1a);
		p1.add(p1b);
		p.add(p2);
		p2.add(p2a);
		p2.add(p2b);
		p.add(p3);
		p3.add(p3a);
		p3a.add(p3aa);
		p3a.add(p3ab);
		p3.add(p3b);
		p3b.add(p3ba);
		p3b.add(p3bb);
		p.add(p4);
		p4.add(p4a);
		p4.add(p4b);
		p.add(p5);
		p5.add(p5a);
		p5.add(p5b);

		//Packing
		setBackground(Color.lightGray);
		pack();
		setBackground(Color.lightGray);

		//Restore real names
		comp1a.setText(str1a);
		comp1b.setText("");
		comp1c.setText(str1c);

		comp2a.setText(str2a);
		comp2c.setText(str2c);

		comp3aa.setText(str3aa);
		comp3ba.setText(str3ba);

		comp4a.setText(str4a);
		comp4c.setText(str4c);

		comp5a.setText(str5a);
		comp5c.setText(str5c);

		//Size
		size=getSize();
		setSize(size);

		project_no();
	
		enableEvents(AWTEvent.WINDOW_EVENT_MASK|
			AWTEvent.COMPONENT_EVENT_MASK);
	}

	// *******************************************************************
	public void actionPerformed(ActionEvent e) 
	{
		String command = e.getActionCommand();

		String prj_file=null;
		String prj_fullname=null;

		int MaxFilS;
		int MaxFilR;
		int MaxDirs;

		int dec;

		int stat;

		if (command.equals(s_m10_10))
		{	        
			if (prj!=null)
			{
				prj_check_save();

				prj=null;
				System.gc();
				System.runFinalization();

				project_no();
			}
			
			try {dec=Integer.decode(fggcfg.Get(10)).intValue();}
			catch (NumberFormatException nfe3) {dec=1024;}
			MaxFilS=dec;

			try {dec=Integer.decode(fggcfg.Get(11)).intValue();}
			catch (NumberFormatException nfe4) {dec=1024;}
			MaxFilR=dec;

			try {dec=Integer.decode(fggcfg.Get(12)).intValue();}
			catch (NumberFormatException nfe5) {dec=1024;}
			MaxDirs=dec;

			prj=new SCS_C_PRJ(null, MaxFilS, MaxFilR, MaxDirs);

			project_yes();
			comp1b.setText("");
			project_update();
		}
		else if (command.equals(s_m10_20))
		{
			FileDialog fd=new FileDialog(this, "Open Project", FileDialog.LOAD);
			fd.show();

			String q1=fd.getFile();
			String q2=fd.getDirectory();
			q2+=q1;

			fd=null;
			System.gc();
			System.runFinalization();

			if (q1!=null)
			{
				if (prj!=null)
				{
					prj_check_save();
			
					prj=null;
					System.gc();
					System.runFinalization();

					project_no();
				}

				prj_file=q1;
				prj_fullname=q2;

				try {dec=Integer.decode(fggcfg.Get(10)).intValue();}
				catch (NumberFormatException nfe6) {dec=1024;}
				MaxFilS=dec;

				try {dec=Integer.decode(fggcfg.Get(11)).intValue();}
				catch (NumberFormatException nfe7) {dec=1024;}
				MaxFilR=dec;

				try {dec=Integer.decode(fggcfg.Get(12)).intValue();}
				catch (NumberFormatException nfe8) {dec=1024;}
				MaxDirs=dec;

				prj=new SCS_C_PRJ(prj_fullname, MaxFilS, MaxFilR, MaxDirs);

				int ret=prj.Load();
				String mes="";

				if (ret!=0)
				{
					if (ret==2) mes="Error: File not found!";
					else if (ret==4) mes="Error: Unknown parameter in project!";
					else mes="Error occured while loading project!";

					MsgBox msgbox=new MsgBox(this, 1, mes);

					msgbox=null;
					prj=null;

					System.gc();
					System.runFinalization();

					project_no();

					return;			
				}

				project_yes();
				comp1b.setText(prj_file);
				project_update();
			}
		} 
		else if (command.equals(s_m10_30))
		{	        
			if (prj!=null) prj_save(false);
		}
		else if (command.equals(s_m10_40))
		{	        
			if (prj!=null) prj_save(true);
		}
		else if (command.equals(s_m10_50))
		{	        
			if (prj!=null)
			{
				prj_check_save();

				prj=null;
				System.gc();
				System.runFinalization();
			}

			project_no();
		}
		else if (command.equals(s_m10_60)) 
		{	        
			prj_check_save();

			SaveCFG();
			System.exit(0);
		} 
		else if (command.equals(s_m20_10))
		{
			stat=0;

			if (prj!=null)
			{
				//
				SCS_C_create_dirs create_dirs=new SCS_C_create_dirs(this, fggcfg, prj);
				stat=create_dirs.getStatus();

				create_dirs=null;

				System.gc();
				System.runFinalization();

				if (stat!=0) return;

				//
				SCS_C_send_files send_files=new SCS_C_send_files(this, fggcfg, prj);
				stat=send_files.getStatus();

				send_files=null;

				System.gc();
				System.runFinalization();

				if (stat!=0) return;

				//
				SCS_C_start_compile start_compile=new SCS_C_start_compile(this, fggcfg, prj);
				stat=start_compile.getStatus();

				start_compile=null;

				System.gc();
				System.runFinalization();

				if (stat!=0) return;

				//
				SCS_C_view_compile view_compile=new SCS_C_view_compile(this, fggcfg, prj);
				stat=view_compile.getStatus();

				view_compile=null;

				System.gc();
				System.runFinalization();

				if (stat!=0) return;

				MsgBox msgbox=new MsgBox(this, 0, "Would you like to continue 'full start'?");

				int ret=msgbox.getRet();

				msgbox=null;

				System.gc();
				System.runFinalization();

				if (ret==2)  return;

				//
				SCS_C_start_run start_run=new SCS_C_start_run(this, fggcfg, prj);
				stat=start_run.getStatus();

				start_run=null;

				System.gc();
				System.runFinalization();

				if (stat!=0) return;

				//
				SCS_C_view_run view_run=new SCS_C_view_run(this, fggcfg, prj);
				stat=view_run.getStatus();

				view_run=null;

				System.gc();
				System.runFinalization();

				if (stat!=0) return;

				MsgBox msgbox1=new MsgBox(this, 0, "Would you like to continue 'full start'?");

				int ret1=msgbox1.getRet();

				msgbox1=null;

				System.gc();
				System.runFinalization();

				if (ret1==2)  return;

				//
				SCS_C_receive_files receive_files=new SCS_C_receive_files(this, fggcfg, prj);
				stat=receive_files.getStatus();

				receive_files=null;

				System.gc();
				System.runFinalization();

				if (stat!=0) return;
			}
		}
		else if (command.equals(s_m20_20))
		{
			if (prj!=null)
			{
				SCS_C_create_dirs create_dirs=new SCS_C_create_dirs(this, fggcfg, prj);

				create_dirs=null;

				System.gc();
				System.runFinalization();
			}
		}
		else if (command.equals(s_m20_30))
		{
			if (prj!=null)
			{
				SCS_C_send_files send_files=new SCS_C_send_files(this, fggcfg, prj);

				send_files=null;

				System.gc();
				System.runFinalization();
			}
		}
		else if (command.equals(s_m20_40))
		{
			if (prj!=null)
			{
				SCS_C_start_compile start_compile=new SCS_C_start_compile(this, fggcfg, prj);

				start_compile=null;

				System.gc();
				System.runFinalization();
			}
		}
		else if (command.equals(s_m20_50))
		{
			if (prj!=null)
			{
				SCS_C_view_compile view_compile=new SCS_C_view_compile(this, fggcfg, prj);

				view_compile=null;

				System.gc();
				System.runFinalization();
			}
		}
		else if (command.equals(s_m20_60))
		{
			if (prj!=null)
			{
				SCS_C_start_run start_run=new SCS_C_start_run(this, fggcfg, prj);

				start_run=null;

				System.gc();
				System.runFinalization();
			}
		}
		else if (command.equals(s_m20_70))
		{
			if (prj!=null)
			{
				SCS_C_view_run view_run=new SCS_C_view_run(this, fggcfg, prj);

				view_run=null;

				System.gc();
				System.runFinalization();
			}
		}
		else if (command.equals(s_m20_80))
		{
			if (prj!=null)
			{
				SCS_C_receive_files receive_files=new SCS_C_receive_files(this, fggcfg, prj);

				receive_files=null;

				System.gc();
				System.runFinalization();
			}
		}
		else if (command.equals(s_m30_10))
		{
			SCS_C_options_client opt_client=new SCS_C_options_client(this, fggcfg);

			opt_client=null;

			System.gc();
			System.runFinalization();
		} 
		else if (command.equals(s_m30_20))
		{
			SCS_C_options_window opt_wnd=new SCS_C_options_window(this, fggcfg);

			opt_wnd=null;

			System.gc();
			System.runFinalization();
		} 
		else if (command.equals(s_m40_10)) 
		{
			SCS_C_about_w frame_about_w=new SCS_C_about_w(this, fggcfg, AppDir, Sep);

			frame_about_w=null;

			System.gc();
			System.runFinalization();
		}
		else if (command.equals(str1d))
		{
			SCS_C_prj_prop prj_prop=new SCS_C_prj_prop(this, fggcfg, prj);

			prj_prop=null;

			System.gc();
			System.runFinalization();

			project_update();
		}
		else if (command.equals(str2d))
		{
			SCS_C_prj_dirs prj_dirs=new SCS_C_prj_dirs(this, fggcfg, prj);

			prj_dirs=null;

			System.gc();
			System.runFinalization();
		}
		else if (command.equals(str3ab))
		{
			SCS_C_prj_FilS prj_FilS=new SCS_C_prj_FilS(this, fggcfg, prj);

			prj_FilS=null;

			System.gc();
			System.runFinalization();
		}
		else if (command.equals(str3bb))
		{

			SCS_C_prj_FilR prj_FilR=new SCS_C_prj_FilR(this, fggcfg, prj);

			prj_FilR=null;

			System.gc();
			System.runFinalization();
		}
	}

	// *******************************************************************
	protected void processEvent(AWTEvent e)
	{
		if (getSize()!=size)
		{
			setSize(size);
		}

		if (e.getID() == Event.WINDOW_DESTROY)
		{
			prj_check_save();

			SaveCFG();
			System.exit(0);
		}
	}

	// *******************************************************************
	private void SaveCFG()
	{
		Point pt;
		String str="";

		if ("1".equals(fggcfg.Get(3)))
		{
			pt=getLocation();

			str=String.valueOf(pt.x);
			SCS_C.fggcfg.Change(1, str);
			str=String.valueOf(pt.y);
			SCS_C.fggcfg.Change(2, str);
		}
	
		SCS_C.fggcfg.Save();
	}

	// *******************************************************************
	private void project_no()
	{
		m10_30.setEnabled(false);
		m10_40.setEnabled(false);
		m10_50.setEnabled(false);

		m20_10.setEnabled(false);
		m20_20.setEnabled(false);
		m20_30.setEnabled(false);
		m20_40.setEnabled(false);
		m20_50.setEnabled(false);
		m20_60.setEnabled(false);
		m20_70.setEnabled(false);
		m20_80.setEnabled(false);

		comp1b.setText("No project ...");
		comp1c.setEnabled(false);
		comp1d.setEnabled(false);
		comp2a.setEnabled(false);
		comp2b.setText("");
		comp2c.setEnabled(false);
		comp2d.setEnabled(false);
		comp3aa.setEnabled(false);
		comp3ab.setEnabled(false);
		comp3ba.setEnabled(false);
		comp3bb.setEnabled(false);
		comp4a.setEnabled(false);
		comp4b.setText("");
		comp4c.setEnabled(false);
		comp4d.setText("");
		comp5a.setEnabled(false);
		comp5b.setText("");
		comp5c.setEnabled(false);
		comp5d.setText("");
	}

	// *******************************************************************
	private void project_yes()
	{
		m10_30.setEnabled(true);
		m10_40.setEnabled(true);
		m10_50.setEnabled(true);

		m20_10.setEnabled(true);
		m20_20.setEnabled(true);
		m20_30.setEnabled(true);
		m20_40.setEnabled(true);
		m20_50.setEnabled(true);
		m20_60.setEnabled(true);
		m20_70.setEnabled(true);
		m20_80.setEnabled(true);

		comp1c.setEnabled(true);
		comp1d.setEnabled(true);
		comp2a.setEnabled(true);
		comp2c.setEnabled(true);
		comp2d.setEnabled(true);
		comp3aa.setEnabled(true);
		comp3ab.setEnabled(true);
		comp3ba.setEnabled(true);
		comp3bb.setEnabled(true);
		comp4a.setEnabled(true);
		comp4c.setEnabled(true);
		comp5a.setEnabled(true);
		comp5c.setEnabled(true);
	}

	// *******************************************************************
	private void project_update()
	{
		String str;

		if (prj!=null)
		{
			comp2b.setText(prj.getMainDir());
			comp4b.setText(prj.getFilesComp());
			comp4d.setText(prj.getOutFile());

			boolean MPI=prj.getMPI();
			if (MPI) str="Yes"; else str="No";
			comp5b.setText(str);

			if (MPI)
			{
				comp5c.setEnabled(true);
				comp5d.setEnabled(true);

				int MPI_Proc=prj.getMPI_Proc();
				str=String.valueOf(MPI_Proc);

				comp5d.setText(str);
			}
			else
			{
				comp5c.setEnabled(false);
				comp5d.setEnabled(false);

				comp5d.setText("");
			}
		}
	}

	// *******************************************************************
	//type = false - save
	//       true  - save as
	private void prj_save(boolean type)
	{
		if (prj!=null)
		{
			String name=prj.getFilename();
	
			if ((name==null) || (name.equals("")) || type) 
			{
				FileDialog fd=new FileDialog(this, "Save Project", FileDialog.SAVE);
				fd.show();

				String prj_file=fd.getFile();
				name=fd.getDirectory();
				name+=prj_file;

				fd=null;
				System.gc();
				System.runFinalization();

				if (prj_file==null) return;
				else
				{
					comp1b.setText(prj_file);

					prj.setFilename(name);
				}
			}

			if (prj.Save()!=0)
			{
				MsgBox msgbox=new MsgBox(this, 1, "Error occured while saving project!");

				msgbox=null;

				System.gc();
				System.runFinalization();
			}
		}
	}

	// *******************************************************************
	private void prj_check_save()
	{
		if (prj!=null)
		{
			if (prj.getSaved()) return;
			else
			{
				MsgBox msgbox=new MsgBox(this, 0, "Save Changes to Project?");

				int ret=msgbox.getRet();

				msgbox=null;

				System.gc();
				System.runFinalization();

				if (ret==1) prj_save(false);
			}
		}
	}
}
