//
// Class SCS_C_options_window
//                  
// Copyright (C) 1998 by Grigori G.Fursin
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;

public class SCS_C_options_window extends Dialog implements ActionListener
{
	//Variables
	Dimension size;

	FGGCFG fggcfg=null;

	Checkbox comp1;
	Checkbox comp2;

	Button comp3a;
	Button comp3b;
	Button comp3c;

	String str3a="Default";
	String str3b="OK";
	String str3c="Cancel";

	// *******************************************************************
	public SCS_C_options_window(Frame dw, FGGCFG xfggcfg)
	{
		super(dw, "Window Options", true);

		int gap=10;

		fggcfg=xfggcfg;

		//First panel for border
		Panel p=new Panel();
		FlowLayout lt=new FlowLayout(FlowLayout.LEFT);
		lt.setHgap(gap);
		lt.setVgap(gap);

		setLayout(lt);

		add(p);

		BorderLayout lt0=new BorderLayout();
		lt0.setHgap(gap);
		lt0.setVgap(gap);

		GridLayout lt1=new GridLayout(2,1);
		lt1.setHgap(gap);
		lt1.setVgap(gap);

		FlowLayout lt2=new FlowLayout(FlowLayout.CENTER);

		SCS_C_FramedArea p1=new SCS_C_FramedArea();
		p1.setLayout(lt1);

		Panel p2=new Panel();
		p2.setLayout(lt2);

		comp1=new Checkbox("Save position of Main Window on exit");
		comp2=new Checkbox("Show \"About Program\" during loading");
		p1.add(comp1); 
		p1.add(comp2);
                
		comp3a=new Button(str3a);
		comp3a.addActionListener(this);
		comp3b=new Button(str3b);
		comp3b.addActionListener(this);
		comp3c=new Button(str3c);
		comp3c.addActionListener(this);

		p2.add(comp3a);
		p2.add(comp3b);
		p2.add(comp3c);

		p.setLayout(lt0);
		p.add("Center", p1);
		p.add("South", p2);		

		//Positioning
		Point pt=dw.getLocationOnScreen();

		setLocation(pt.x+40, pt.y+40);

		//Packing elements in window
		pack();

		size=getSize();
		
		//Updating parameters
		my_update();

		enableEvents(AWTEvent.WINDOW_EVENT_MASK|
			AWTEvent.COMPONENT_EVENT_MASK);

		show();
	}

	// *******************************************************************
	public void actionPerformed(ActionEvent e) 
	{
		String x;

		String command = e.getActionCommand();
		if (command.equals(str3a)) 
		{	        
			String xstr3=fggcfg.Get(3);
			String xstr4=fggcfg.Get(4);

			SCS_C_misc.default_cfg(fggcfg, 1);
			my_update();

			fggcfg.Change(3, xstr3);
			fggcfg.Change(4, xstr4);
		} 
		else if (command.equals(str3b))
		{           
			if (comp1.getState()==false) x="0"; else x="1";
			fggcfg.Change(3,x);

			if (comp2.getState()==false) x="0"; else x="1";
			fggcfg.Change(4,x);

			SCS_C_misc.check_cfg(fggcfg, 1);

			fggcfg.Save();
	
			dispose();
		} 
		else if (command.equals(str3c)) 
		{
			dispose();
		} 
	}

	// *******************************************************************
	protected void processEvent(AWTEvent e)
	{
		if (getSize()!=size)
		{
			setSize(size);
		}

		if (e.getID() == Event.WINDOW_DESTROY)
		{
        		dispose();
		}
	}

	// *******************************************************************
	private void my_update()
	{
		boolean x;

		if ("1".equals(fggcfg.Get(3))) x=true; else x=false;
		comp1.setState(x);

		if ("1".equals(fggcfg.Get(4))) x=true; else x=false;
		comp2.setState(x);
	}
}
