//
// Class SCS_C_view_compile
//                  
// Copyright (C) 1998 by Grigori G.Fursin
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

import java.io.*;

public class SCS_C_view_compile extends Dialog implements ActionListener, Runnable
{
	//Variables
	Dimension size;

	FGGCFG fggcfg=null;
	SCS_C_PRJ prj=null;

	Label comp1a;
	Label comp1b;
	Label comp1c;
	Label comp1d;
	Label comp2;
	Button comp3;

	String str1a="Timer:";
	String str1b="000000";
	String str1c="Period:";
	String str1d="000000";

	String str2a="Idle";
	String str2b="Sending request to SCS Server ...";
	String str2c="Getting response from SCS Server ...";
	String str3="Cancel";

	Frame Parent=null;

	Thread thrd=null;

	int Status;

	private static URL url_adr=null;
	private static URLConnection url_conn=null;

	String str_view_compile="SCS_C_READY_COMPILE=";

	InputStream is=null;
	OutputStream os=null;
	StringBuffer url_resp=null;

	String str_id_compile;

	// *******************************************************************
	public SCS_C_view_compile(Frame dw, FGGCFG xfggcfg, SCS_C_PRJ xprj)
	{
		super(dw, "Get status of 'compile' job", true);

		Status=0;

		Parent=dw;

		int gap=10;

		fggcfg=xfggcfg;
		prj=xprj;

		//Checking ID_COMPILE
		str_id_compile=prj.getCompileID();
		if ((str_id_compile==null) || (str_id_compile.equals("")))
		{
			MsgBox msgbox=new MsgBox(Parent, 1, "Warning: Can't find ID of 'compile' job in project!");

			msgbox=null;

			System.gc();
			System.runFinalization();

			Status=1;

			dispose();

			return;
		}

		//First panel for border
		Panel p=new Panel();
		FlowLayout lt=new FlowLayout(FlowLayout.CENTER);
		lt.setHgap(gap);
		lt.setVgap(gap);

		setLayout(lt);

		add(p);

		BorderLayout lt0=new BorderLayout();
		lt0.setHgap(gap);
		lt0.setVgap(gap);

		GridLayout lt1=new GridLayout(2,2);

		FlowLayout lt2=new FlowLayout(FlowLayout.CENTER);

		FlowLayout lt3=new FlowLayout(FlowLayout.CENTER);

		Panel p0=new Panel();
		p0.setLayout(lt0);

		SCS_C_FramedArea p1=new SCS_C_FramedArea();
		p1.setLayout(lt1);

		SCS_C_FramedArea p2=new SCS_C_FramedArea();
		p2.setLayout(lt2);

		Panel p3=new Panel();
		p3.setLayout(lt2);

		comp1a=new Label(str1a, Label.LEFT);
		comp1b=new Label(str1b, Label.RIGHT);
		comp1c=new Label(str1c, Label.LEFT);
		comp1d=new Label(str1d, Label.RIGHT);

		comp2=new Label(str2c, Label.CENTER);

		comp3=new Button(str3);
		comp3.addActionListener(this);

		p.add(p0);
	
		p0.add("North", p1);
		p0.add("Center", p2);
		p0.add("South", p3);

		p1.add(comp1a);
		p1.add(comp1b);
		p1.add(comp1c);
		p1.add(comp1d);

		p2.add(comp2);
		p3.add(comp3);

		//Positioning
		Point pt=dw.getLocationOnScreen();

		setLocation(pt.x+40, pt.y+40);

		//Packing elements in window
		pack();

		size=getSize();
		
		enableEvents(AWTEvent.WINDOW_EVENT_MASK|
			AWTEvent.COMPONENT_EVENT_MASK);

		thrd=new Thread(this);
		thrd.start();		

		show();
	}

	// *******************************************************************
	public void actionPerformed(ActionEvent e) 
	{
		String command = e.getActionCommand();

		if (command.equals(str3)) 
		{	
			closeWWW();

			Status=-1;

			thrd.suspend();

			dispose();
		} 
	}

	// *******************************************************************
	protected void processEvent(AWTEvent e)
	{
		if (getSize()!=size)
		{
			setSize(size);
		}

		if (e.getID() == Event.WINDOW_DESTROY)
		{
			closeWWW();

			Status=-1;

			thrd.suspend();

        		dispose();
		}
	}

	// *******************************************************************
	public void run()
	{
		String warn;

		String x1;
		String x2;

		int c;

		int dec;

		String http_server=fggcfg.Get(18);

		x1=SCS_C_misc.str_check_del_l(http_server, "http:");
		http_server=x1;
		x1=SCS_C_misc.str_check_del_l(http_server, "/");
		http_server=x1;
		x1=SCS_C_misc.str_check_del_l(http_server, "/");
		http_server=x1;
		x1=SCS_C_misc.str_check_del_l(http_server, "\\");
		http_server=x1;
		x1=SCS_C_misc.str_check_del_l(http_server, "\\");
		http_server=x1;
		x1=SCS_C_misc.str_check_del_r(http_server, "/");
		http_server=x1;
		x1=SCS_C_misc.str_check_del_r(http_server, "\\");
		http_server="http://"+x1;

		int timer=0;
		int timer_end=prj.getPeriod();
		if (timer_end==0) timer_end=1;

		comp1b.setText("0");
		comp1d.setText(String.valueOf(timer_end));

                boolean quit=false;
		while (!quit)
		{
			comp2.setText(str2a);
			try
			{
				thrd.sleep(1000);
			}
			catch (InterruptedException e)
			{
				System.out.print("Fatal Error occured during work with thread in SCS_C_view_compile.class!\n");
				SCS_C_misc.ask_key();
				System.exit(1);
			}
			
			timer++;
			comp1b.setText(String.valueOf(timer));
			
			if (timer>=timer_end)
			{
				timer=0;

				System.gc();
				System.runFinalization();

				comp2.setText(str2b);

				//Create URL
				try
				{
					url_adr=new URL(http_server);
		        	}
				catch (MalformedURLException e1)
				{
					warn="Error while connecting to SCS Server ("+e1.getMessage()+")!";

					MsgBox msgbox=new MsgBox(Parent, 1, warn);

					msgbox=null;
        	
					System.gc();
					System.runFinalization();

					Status=1;
					dispose();
					return;
				}

				//Connect
				try
				{
					url_conn=url_adr.openConnection();
		        	}
				catch (IOException e2)
				{
					warn="Error while connecting to SCS Server ("+e2.getMessage()+")!";

					MsgBox msgbox=new MsgBox(Parent, 1, warn);

					msgbox=null;
        	
					System.gc();
					System.runFinalization();

					Status=1;
					dispose();
					return;
				}

				//Send POST data to Server
				url_conn.setDoOutput(true);

				try
				{
					os=url_conn.getOutputStream();

					x1="Login=";
					x1+=SCS_C_misc.inet_parse(fggcfg.Get(13));
					x1+="&";
					SCS_C_misc.inet_send_post_data(os, x1);

					x1="Password=";
					x1+=SCS_C_misc.inet_parse(fggcfg.Get(14));
					x1+="&";
					SCS_C_misc.inet_send_post_data(os, x1);

					x1="IDCompile=";
					x1+=SCS_C_misc.inet_parse(prj.getCompileID());
					SCS_C_misc.inet_send_post_data(os, x1);

					os.close();
					os=null;
				}
				catch(IOException e3)
				{
					warn="Error while sending POST data to SCS Server ("+e3.getMessage()+")!";

					MsgBox msgbox=new MsgBox(Parent, 1, warn);

					msgbox=null;
        	
					System.gc();
					System.runFinalization();

					closeWWW();

					Status=1;
					dispose();
					return;
				}

				try
				{
					thrd.sleep(250);
				}
				catch (InterruptedException e)
				{
					System.out.print("Fatal Error occured during work with thread in SCS_C_view_compile.class!\n");
					SCS_C_misc.ask_key();
					System.exit(1);
				}

				//Get response
				comp2.setText(str2c);

				url_resp=new StringBuffer();

				try
				{
					is=url_conn.getInputStream();

					while ((c=is.read())!=-1) 
					{
						url_resp.append((char) c);
					}

					is.close();
					is=null;
				}
				catch(IOException e3)
				{
					warn="Error while receiving response from SCS Server ("+e3.getMessage()+")!";

					MsgBox msgbox=new MsgBox(Parent, 1, warn);

					msgbox=null;
        	
					System.gc();
					System.runFinalization();

					closeWWW();

					Status=1;
					dispose();
					return;
				}

				String url_resp_str=url_resp.toString();
				String url_resp_str_u=url_resp_str.toUpperCase();

				int ind=url_resp_str_u.indexOf(str_view_compile);

				int compile_ready=0;
				if (ind!=-1)
				{
					int il=str_view_compile.length();
					int il1=url_resp_str_u.length();
					ind+=il;
					if (ind<il1)
					{
						int il2=0;
						for (int j=ind; j<il1; j++)
						{
							char c1=url_resp_str_u.charAt(j);
							if (!Character.isDigit(c1)) break;
							il2++;
						}

						if (il2!=0)
						{
							x1=url_resp_str.substring(ind, ind+il2);
							try {dec=Integer.decode(x1).intValue();}
							catch (NumberFormatException nfe1) {dec=0;}
							compile_ready=dec;
						}
					}

					if (compile_ready!=0)
					{
						//'compile' job is ready!
						MsgBox msgbox=new MsgBox(Parent, 0, "'Compile' job is READY! Would you like to view the response?");

						int ret=msgbox.getRet();

						msgbox=null;

						System.gc();
						System.runFinalization();

						if (ret==1) 
						{
							SCS_C_view_list view_list=new SCS_C_view_list(Parent, "View the response from SCS Server", url_resp_str, 18, 70);

							view_list=null;

							System.gc();
							System.runFinalization();
						}

						Status=0;
						quit=true;
					}
				}
                                else
				{
					//READY_COMPILE not found
					MsgBox msgbox=new MsgBox(Parent, 0, "Warning: Status of 'compile' job was not found! Would you like to view the response?");

					int ret=msgbox.getRet();

					msgbox=null;

					System.gc();
					System.runFinalization();

					if (ret==1) 
					{
						SCS_C_view_list view_list=new SCS_C_view_list(Parent, "View the response from SCS Server", url_resp_str, 18, 70);

						view_list=null;

						System.gc();
						System.runFinalization();
					}

					Status=1;

		        		dispose();

					return;
				}
			}

			url_conn=null;
			url_resp=null;
                }

		//Closing
		Status=0;
  		dispose();
	}

	// *******************************************************************
	public int getStatus()
	{
		return Status;
	}

	// *******************************************************************
	public void closeWWW()
	{
		try
		{
			if (os!=null) os.close();
			if (is!=null) is.close();
		}
		catch(IOException e1)
		{
			String warn="Error while closing streams ("+e1.getMessage()+")!";

			MsgBox msgbox=new MsgBox(Parent, 1, warn);

			msgbox=null;
        	
			System.gc();
			System.runFinalization();

			return;
		}
	}
}
