// WndDlg.cpp : Implementation file
//

// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1997 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

/*****************************************************************************
  Development Team:
    Mary Kirtland
  Ported to 32-bit by:
    Mike Hedley	
  Created by Microsoft Product Support Services, Premier ISV Support
  Copyright (c) 1997 Microsoft Corporation. All rights reserved.
\****************************************************************************/

#include "stdafx.h"
#include <afxpriv.h>
#include "resource.h"
#include "wnddlg.h"  

#include <afxdb.h>

#include "About.h"
#include "OptWnd.h"
#include "OptServ.h"
#include "job.h"
#include "KillJob.h"

#include "fggcfg.h"
extern CFGGCfg* fggcfg;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
                 
/////////////////////////////////////////////////////////////////////////////
// CWndDlg control bar data 

static UINT auIDStatusBar[] = { 
NULL
	//   ID_SEPARATOR
};         

static UINT auIDToolBar[] = { 
	ID_EXIT,
	ID_SEPARATOR,
	ID_START_SERVER,
	ID_STOP_SERVER,
	ID_SEPARATOR,
	ID_KILL_JOB,
	ID_SEPARATOR,
	ID_ABOUT
};

/////////////////////////////////////////////////////////////////////////////
// CWndDlg dialog

CWndDlg::CWndDlg()
{
	//{{AFX_DATA_INIT(CWndDlg)
	//}}AFX_DATA_INIT
}

BOOL CWndDlg::Create()
{
	return CModelessMain::Create(CWndDlg::IDD,
								 auIDStatusBar, 
								 sizeof(auIDStatusBar)/sizeof(UINT),
								 auIDToolBar,
								 sizeof(auIDToolBar)/sizeof(UINT),
								 IDR_MAIN);	
}								 

void CWndDlg::DoDataExchange(CDataExchange* pDX)
{
	CModelessMain::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWndDlg)
	DDX_Control(pDX, IDC_STATIC3, m_st3);
	DDX_Control(pDX, IDC_STATIC2, m_st2);
	DDX_Control(pDX, IDC_STATIC1, m_st1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWndDlg, CModelessMain)
	//{{AFX_MSG_MAP(CWndDlg)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_COMMAND(ID_START_SERVER, OnStartServer)
	ON_COMMAND(ID_STOP_SERVER, OnStopServer)
	ON_UPDATE_COMMAND_UI(ID_START_SERVER, OnUpdateStartServer)
	ON_UPDATE_COMMAND_UI(ID_STOP_SERVER, OnUpdateStopServer)
	ON_COMMAND(ID_ABOUT, OnAbout)
	ON_COMMAND(ID_EXIT, OnExit)
	ON_COMMAND(ID_OPTIONS_SERVER, OnOptionsServer)
	ON_COMMAND(ID_OPTIONS_WINDOW, OnOptionsWindow)
	ON_UPDATE_COMMAND_UI(ID_ABOUT, OnUpdateAbout)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_SERVER, OnUpdateOptionsServer)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_WINDOW, OnUpdateOptionsWindow)
	ON_COMMAND(ID_KILL_JOB, OnKillJob)
	ON_UPDATE_COMMAND_UI(ID_KILL_JOB, OnUpdateKillJob)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CWndDlg::OnInitDialog

BOOL CWndDlg::OnInitDialog()
{
	CModelessMain::OnInitDialog();   
	
	// Initialize windows contents
	CMenu *pMenu=GetSystemMenu(FALSE);
	if (pMenu!=NULL)
	{
		pMenu->DeleteMenu(SC_MAXIMIZE, MF_BYCOMMAND);
		pMenu->DeleteMenu(SC_SIZE, MF_BYCOMMAND);
	}
	
	COLORREF clr;	

	pDC=new CClientDC(this);

	clr=RGB(255,0,0);
	pMyPen1=new CPen(PS_SOLID,1,clr);
	pMyBrush1=new CBrush(clr);

	clr=RGB(0,255,0);
	pMyPen2=new CPen(PS_SOLID,1,clr);
	pMyBrush2=new CBrush(clr);

	pMyPen3=new CPen(PS_NULL, 1, RGB(255,255,255));

	GetDlgItem(IDC_STATIC21)->GetWindowRect(&rect1);
	GetDlgItem(IDC_STATIC22)->GetWindowRect(&rect2);
	ScreenToClient(&rect1);
	ScreenToClient(&rect2);

	ix1=rect1.right-rect1.left;
	iy1=rect1.bottom-rect1.top;
	ix2=rect2.right-rect2.left;
	iy2=rect2.bottom-rect2.top;

	ir1=min(ix1,iy1);
	ir2=min(ix2,iy2);

	init();

	if (strcmp(fggcfg->Get(22),"1")==0) OnStartServer();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CWndDlg::OnClose
//		OnClose makes sure the 1sec timer is destroyed when the dialog
//		is closed.

void CWndDlg::OnClose() 
{
	OnStopServer();
	SaveCFG();

	CModelessMain::OnClose();
} 

void CWndDlg::SaveCFG(void)
{
	if (strcmp(fggcfg->Get(3),"1")==0)
	{
		CRect rect;
		GetWindowRect(&rect);
	
		char misc[64];
	
		ultoa(rect.left,misc,10);
		fggcfg->Change(1,&misc[0]);
		ultoa(rect.top,misc,10);
		fggcfg->Change(2,&misc[0]);
	}

	fggcfg->Save();
}

void CWndDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CString str;
	CDatabase db;
	CRecordset fQuery(&db);

	unsigned long jobs;

	char str1[StrMaxLen];
	TCHAR szError[StrMaxLen];

	if (status_of_timer) UpdateData(false);
	else if (jobs_timer)
	{
		status_of_timer=true;
		
		tim=0;
		DrawReq();

		jobs=0;

		//Connecting to database 'Jobs' through ODBC
		try
		{
			//Open database
			if (!db.Open(_TEXT(fggcfg->Get(11)), FALSE, FALSE, _T("ODBC;"), FALSE))
			{
				AfxMessageBox("Fatal Internal Error: Can't connect to database [E010]!");
				OnStopServer();
			}
			else
			{
				strcpy(str1, "SELECT Compile.* "
				             "FROM Accounts INNER JOIN Compile ON Accounts.ID_USER=Compile.ID_USER "
				             "WHERE (((Compile.READY)=No) AND ((Compile.MAY_BE_KILLED)=No) AND ((Accounts.ACTIVE)=Yes)) "
							 "ORDER BY Accounts.PRIORITY");

				if (!fQuery.Open(AFX_DB_USE_DEFAULT_TYPE, _TEXT(str1)))
				{
					AfxMessageBox("Fatal Internal Error: Can't open Query to database [E020]!");
					OnStopServer();
				}
				else 
				{
					if (!fQuery.IsEOF())
					{
						while (!fQuery.IsEOF())
						{
							jobs++;
							fQuery.MoveNext();
						}
					}
					fQuery.Close();
				}
			
				db.Close();
			}
		}
		catch (CDBException *pEx)
		{
			str="Fatal Internal Error (while working with database) [E030]:\n";
			if (pEx->GetErrorMessage(szError, sizeof(szError)))
			{
				str+=szError;
			}
			AfxMessageBox(str);
			OnStopServer();
		}

		//Print number of jobs
		str.Format("%u",jobs);
		GetDlgItem(IDC_STATIC3)->SetWindowText(str);
		UpdateData(false);
				
		if (jobs!=0)
		{
			//Call compile window
			CJob job;
			unsigned int ret=job.DoModal();
			delete job;
			UpdateData(false);
			if (ret==IDCANCEL) OnStopServer();
		}
//		else jobs_timer=false; //To perform all compile jobs, then suspend for some time
		jobs_timer=false;
		
		status_of_timer=false;
	}
	else if (!suspended)
	{
		status_of_timer=true;
		tim++;

		str.Format("%u",tim);
		GetDlgItem(IDC_STATIC1)->SetWindowText(str);
	
		if (tim>=tim_max) 
		{
			tim=0;
			DrawReq();
		
			jobs_timer=true;
		}
		else DrawIdle();
		
		status_of_timer=false;
	}
	
	CModelessMain::OnTimer(nIDEvent);
}

void CWndDlg::init(void)
{
	jobs_timer=false;
	working=false;
	suspended=false;
	status_of_timer=false;
	
	my_close();
	
	tim=0;
	tim_max=atoi(fggcfg->Get(10));
	
	CString str;
	str.Format("%u",tim_max);
	m_st1.SetWindowText(_T("0"));
	m_st2.SetWindowText(_TEXT(str));
	m_st3.SetWindowText(_T("0"));

	DrawClear();
	
	UpdateData(false);
}

void CWndDlg::OnStartServer() 
{
	// TODO: Add your command handler code here
	init();

	working=true;

	m_timer = NULL;
	m_timer = SetTimer(1, 1000, NULL);

	if (m_timer==NULL)
	{
		MessageBox(_T("Not enough timers available for this window!"),
				_T("Warning"), MB_ICONEXCLAMATION | MB_OK);

		// signal creation failure...
		OnStopServer();
	}
}

void CWndDlg::OnStopServer() 
{
	// TODO: Add your command handler code here
	init();

	working=false;
}

void CWndDlg::OnUpdateStartServer(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!working);
}

void CWndDlg::OnUpdateStopServer(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(working);
}

void CWndDlg::my_close(void) 
{
	if (m_timer)
	{
		KillTimer(m_timer);
		m_timer = NULL;
	}
}

void CWndDlg::DrawIdle(void)
{
	// TODO: Add your message handler code here and/or call default
	pDC->SelectObject(pMyPen1);
	pDC->SelectObject(pMyBrush1);
	pDC->Ellipse(rect1.left,rect1.top,rect1.left+ir1,rect1.top+ir1);

	pDC->SelectObject(pMyPen2);
	pDC->SelectStockObject(LTGRAY_BRUSH);
	pDC->Ellipse(rect2.left,rect2.top,rect2.left+ir2,rect2.top+ir2);

	UpdateData(false);
}

void CWndDlg::DrawReq(void)
{
	// TODO: Add your message handler code here and/or call default
	pDC->SelectObject(pMyPen2);
	pDC->SelectObject(pMyBrush2);
	pDC->Ellipse(rect2.left,rect2.top,rect2.left+ir2,rect2.top+ir2);

	pDC->SelectObject(pMyPen1);
	pDC->SelectStockObject(LTGRAY_BRUSH);
	pDC->Ellipse(rect1.left,rect1.top,rect1.left+ir1,rect1.top+ir1);

	UpdateData(false);
}

void CWndDlg::DrawClear(void)
{
	// TODO: Add your message handler code here and/or call default
	pDC->SelectObject(pMyPen3);
	pDC->SelectStockObject(LTGRAY_BRUSH);
	pDC->Rectangle(rect1.left-1,rect1.top-1,rect1.left+ir1+1,rect1.top+ir1+1);
	pDC->Rectangle(rect2.left-1,rect2.top-1,rect2.left+ir2+1,rect2.top+ir2+1);

	UpdateData(false);
}

void CWndDlg::OnAbout() 
{
	// TODO: Add your command handler code here
	suspended=true;

	CAbout about;
	about.DoModal();

	suspended=false;
}

void CWndDlg::OnExit() 
{
	// TODO: Add your command handler code here
	OnStopServer();
	SaveCFG();	

	exit(0);
}

void CWndDlg::OnOptionsServer() 
{
	// TODO: Add your command handler code here
	suspended=true;
	
	COptServ OptServ;
	if (OptServ.DoModal()==IDOK) OnStopServer();

	suspended=false;
}

void CWndDlg::OnOptionsWindow() 
{
	// TODO: Add your command handler code here
	suspended=true;
	
	COptWnd OptWnd;
	OptWnd.DoModal();

	suspended=false;
}

void CWndDlg::OnUpdateAbout(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!jobs_timer);	
}

void CWndDlg::OnUpdateOptionsServer(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!jobs_timer);
}

void CWndDlg::OnUpdateOptionsWindow(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!jobs_timer);
}

void CWndDlg::OnKillJob() 
{
	// TODO: Add your command handler code here
	suspended=true;
	
	CKillJob KillJob;
	KillJob.DoModal();

	suspended=false;
}

void CWndDlg::OnUpdateKillJob(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!jobs_timer);	
}
