#include "windows.h"
#include "stdio.h"
#include "debuglog.h"

#ifndef DEBUGLOGFILENAME
#error	You must define DEBUGFILENAME to be the name of a file to log messages
#endif

static BOOL fDebug = FALSE;
static FILE *debugLog = NULL;

DWORD OpenDebugLog(LPCSTR szFlags)
{
	if (NULL != debugLog)
	{
		fflush(debugLog);
		fclose(debugLog);
		debugLog = NULL;
	}
	debugLog = fopen(DEBUGLOGFILENAME,szFlags);
	if (NULL != debugLog)
		return ERROR_SUCCESS;
	else
		return GetLastError();
}

VOID CloseDebugLog(void)
{
	if (NULL != debugLog)
	{
		fflush(debugLog);
		fclose(debugLog);
		debugLog = NULL;
	}
}

DWORD WriteDebugLog(LPCSTR szMsg)
{
	DWORD dwStatus = ERROR_SUCCESS;
	int nBytesWritten = 0;
	BOOL fOpenedByMe = FALSE;

	if (NULL == debugLog)
	{
		debugLog = fopen(DEBUGLOGFILENAME,"a+");
		if (NULL == debugLog)
		{
			dwStatus = GetLastError();
			goto cleanup;
		}
		fOpenedByMe = TRUE;
	}
	nBytesWritten = fprintf(debugLog,szMsg);
	if (0 < nBytesWritten)
	{
		nBytesWritten = fflush(debugLog);
		if (EOF == nBytesWritten)
		{
			dwStatus = GetLastError();
			goto cleanup;
		}
		dwStatus = ERROR_SUCCESS;
	}
	if (fOpenedByMe && (ERROR_SUCCESS == dwStatus))
	{
		fclose(debugLog);
		debugLog = NULL;
	}
cleanup:
	return dwStatus;
}
