#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <tchar.h>
#include <winsock.h>
#include "service.h"
#include "processinfo.h"
#include "mpiserve.h"
#include "SocketReadAndWrite.h"
#include "MPIServePacket.h"
#include "MPIJobQueue.h"
#include "packets.h"
#include "infoprint.h"
#include "mpirun.h"
#include "crtdbg.h"

void FreeWorldProcessMap(WORLDPROCESSMAP *WorldProcessMap)
{
	_ASSERTE(WorldProcessMap);
	if (WorldProcessMap)
	{
		; /* Do nothing here... nothing to free */
	}
}


void FreeJobInfo(JOBINFO *JobInfo)
{
	DWORD i;

	_ASSERTE(JobInfo);
	if (JobInfo)
	{
		if (JobInfo->hBarrierSemaphore)
			CloseHandle(JobInfo->hBarrierSemaphore);
		if (JobInfo->hBarrierEvent)
			CloseHandle(JobInfo->hBarrierEvent);
		if (JobInfo->hGlobalTerminatorEvent)
			CloseHandle(JobInfo->hBarrierEvent);
		if (JobInfo->hLocalProcessHandles)
			CloseHandle(JobInfo->hLocalProcessHandles);
		if (JobInfo->hTCPIPProcBuffer)
			CloseHandle(JobInfo->hTCPIPProcBuffer);
		for (i=0; i < JobInfo->Machine[JobInfo->dwMyMachineID].dwNumProcesses; i++)
		{
			if (JobInfo->Machine[JobInfo->dwMyMachineID].Process[i].hSharedMemoryBuffer)
			{
				MPID_WINNT_SHMEM_BUFFER_T *pBuf;

				pBuf = (MPID_WINNT_SHMEM_BUFFER_T *)MapViewOfFile(JobInfo->Machine[JobInfo->dwMyMachineID].Process[i].hSharedMemoryBuffer,
																  FILE_MAP_ALL_ACCESS,
																  0,
																  0,
																  0);
				_ASSERTE(pBuf);
				if (pBuf->hBufferEmpty)
					CloseHandle(pBuf->hBufferEmpty);
				if (pBuf->hBufferFull)
					CloseHandle(pBuf->hBufferFull);
				if (pBuf->hMutex)
					CloseHandle(pBuf->hMutex);
				UnmapViewOfFile(pBuf);
			}
		}
	}
}



void FreeLocalProcessHandles(LOCALPROCESSHANDLES *LocalProcessHandles)
{
	DWORD i;

	_ASSERTE(LocalProcessHandles);
	for (i=0; i < LocalProcessHandles->dwNumHandles; i++)
	{
		if (LocalProcessHandles->hProc[i])
		{
			CloseHandle(LocalProcessHandles->hProc[i]);
			LocalProcessHandles->hProc[i] = NULL;
		}
		if (LocalProcessHandles->hThread[i])
		{
			CloseHandle(LocalProcessHandles->hThread[i]);
			LocalProcessHandles->hThread[i] = NULL;
		}
	}
}


