#ifndef _MPISERVEPACKET_H_
#define _MPISERVEPACKET_H_

#ifndef MPI_SERVICE_PORT_NUMBER
#define MPI_SERVICE_PORT_NUMBER		12396
#endif

#include "processinfo.h"

#define MPISERVESTRINGLEN	256

typedef enum _TASKS
{
	MPI_SERVE_QUERY_INFO = 1,
	MPI_SERVE_CREATE_SINGLE_PROCESS,
	MPI_SERVE_KILL_SINGLE_PROCESS,
	MPI_SERVE_START_MPI_JOB,
	MPI_KILL_MPI_JOB,
} TASK_TYPE;

typedef struct _QueryPacket
{
	/* This hasn't been determined yet */
	DWORD dwDummy;
} MPIServeQueryInfoPacket_T;

typedef struct _QueryReturnPacket
{
	/* This hasn't been determined yet */
	DWORD dwDummy;
} MPIServeQueryReturnInfoPacket_T;

typedef struct _CreateSingleProc
{
	char szExecutableName[MPISERVESTRINGLEN];
	BOOL fBlocking;
} MPIServeCreateSingleProcessPacket_T;

typedef struct _CreateSingleProcReturnData
{
	DWORD dwProcessID;
	HANDLE hProcess;
	DWORD dwStatus;
	DWORD dwProcessExitStatus;
} MPIServeCreateSingleProcessReturnDataPacket_T;

typedef struct _KillSingleProc
{
	DWORD dwProcessID;
	HANDLE hProcess;
	DWORD dwExitCode;
} MPIServeKillSingleProcessPacket_T;

typedef struct _KillSingleProcReturnData
{
	DWORD dwStatus;
	BOOL fStatus;
} MPIServeKillSingleProcessReturnDataPacket_T;


typedef struct _StartMPIJob
{
	char	szJobID[MPISERVESTRINGLEN];
	BOOL	fBlocking;
	DWORD	dwMyMachineID;
	WORD	MPIPortNumber;
	JOBINFO	JobInfo;
	WORLDPROCESSMAP WorldProcessMap;
} MPIServeStartMPIJobPacket_T;

typedef struct _StartMPIJobReturnData
{
	DWORD dwStatus;
	DWORD dwExitCodes[MAX_NUM_SHMEM_PROCS];
} MPIServeStartMPIJobReturnDataPacket_T;

typedef struct _KillMPIJob
{
	char szJobID[MPISERVESTRINGLEN];
} MPIServeKillMPIJobPacket_T;

typedef struct _MPIServePacket
{
	TASK_TYPE eTask;
	union
	{
		MPIServeQueryInfoPacket_T QueryPacket;
		MPIServeQueryReturnInfoPacket_T QueryReturnPacket;
		MPIServeCreateSingleProcessPacket_T CreateSingleProcessPacket;
		MPIServeCreateSingleProcessReturnDataPacket_T CreateSingleProcessReturnDataPacket;
		MPIServeKillSingleProcessPacket_T KillSingleProcessPacket;
		MPIServeStartMPIJobPacket_T StartMPIJobPacket;
		MPIServeKillMPIJobPacket_T  KillMPIJobPacket;
	} uPacket;

} MPIServePacket_T;

#endif
