//  MODULE:   DeleteRegistryInfo.c
//
//  PURPOSE:  Deletes the registry information used by the service
//
//  FUNCTIONS:
//
//		LONG DeleteRegistryInfo()
//
//  COMMENTS:
//
//  AUTHOR: Shane Hebert
//


#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <tchar.h>
#include <winsock.h>
#include "service.h"


//
//  FUNCTION: DeleteRegistryInfo()
//
//  PURPOSE: delete the registry info for the service
//			initially, this is the port number to listen
//			to and possibly the version number
//
//  PARAMETERS:
//		NONE
//
//  RETURN VALUE:
//    status
//
//  COMMENTS:
//
LONG DeleteRegistryInfo()
{
	LONG nStatus = ERROR_SUCCESS;
	HKEY hkSoftwareSubKey;

	//  Open HKEY_LOCAL_MACHINE
	nStatus = RegOpenKeyEx(
			HKEY_LOCAL_MACHINE,
			TEXT(SZSOFTWARESUBKEY),
			0,
			KEY_ALL_ACCESS,
			&hkSoftwareSubKey);
	if (ERROR_SUCCESS == nStatus)
	{
		// Delete the whole MPI Server key
		nStatus = RegDeleteKey(
					hkSoftwareSubKey,
					TEXT(SZMPISUBKEY));
	}
	if (ERROR_SUCCESS != nStatus)
	{
		TCHAR szMsg[512];
		GetLastErrorText(szMsg,512);
		AddToMessageLog(szMsg);
	}
	else{
		RegCloseKey(hkSoftwareSubKey);
	}
	return nStatus;
}

