#include <stdio.h>
#include <windows.h>
#include <windowsx.h>
#include "packets.h"
#include "stdlib.h"
#include "time.h"
#include "mpitcpproc.h"
#include "sockutil.h"
#include "debuglog.h"

SOCKET *sSocket;

BOOL EstablishTCPConnections(JOBINFO *JobInfo,WORD wPortNumber,int *status)
{
	extern DWORD dwNumMachines;
	extern DWORD dwMyID;
	extern int rank;
	extern int world;
	WORD wVersionRequested = MAKEWORD(1,1);
	WSADATA wsaData;
	BOOL wsaInit=FALSE;
	SOCKET sListener;
	int nStatus;
	int i;
	int enable=1;

	*status = ERROR_SUCCESS;
	sSocket = (SOCKET*)malloc(dwNumMachines*sizeof(SOCKET));
	if (0 == sSocket)
		goto error;
	nStatus = WSAStartup(wVersionRequested,&wsaData);
	if (SOCKET_ERROR == nStatus)
		goto error;
	wsaInit = TRUE;
	{
		SOCKADDR_IN aLocalAddress;

		sListener = socket(AF_INET,SOCK_STREAM,0);
		if (INVALID_SOCKET == sListener)
			goto error;
		memset(&aLocalAddress,0,sizeof(SOCKADDR_IN));
		aLocalAddress.sin_port = htons(wPortNumber);
		aLocalAddress.sin_family = AF_INET;
		nStatus = bind(sListener,(PSOCKADDR)&aLocalAddress,sizeof(SOCKADDR_IN));
		if (SOCKET_ERROR == nStatus)
			goto error;
		nStatus = listen(sListener,dwMyID);
		if (SOCKET_ERROR == nStatus)
			goto error;
	}
	for (i=0;i<(LONG)dwMyID;i++)
	{
		int ID;
		SOCKET sAccept;
		sAccept = accept(sListener,NULL,NULL);
		if (INVALID_SOCKET == sAccept)
			goto error;
		nStatus = RecvSocketN(sAccept,(BYTE*)&ID,sizeof(int));
		if (SOCKET_ERROR == nStatus)
			goto error;
		sSocket[ID] = sAccept;
		setsockopt(sSocket[ID],IPPROTO_TCP,TCP_NODELAY,(char*)&enable,sizeof(int));
		printf("Connected with machine [%d]\n",ID);
	}
	/*
		Skip myself and then initiate the rest of the
		connections.	
	*/
	sSocket[dwMyID] = 0;
	for (i=(LONG)dwMyID+1; i < (LONG)dwNumMachines;i++)
	{
		struct hostent *pheEnt;
		SOCKET s1;
		SOCKADDR_IN aAddress;

		pheEnt = gethostbyname(JobInfo->Machine[i].szMachineName);
		if (NULL == pheEnt)
			goto error;
		aAddress.sin_port = htons(wPortNumber);
		aAddress.sin_family = AF_INET;
		memcpy(&aAddress.sin_addr,pheEnt->h_addr,pheEnt->h_length);
		s1 = socket(pheEnt->h_addrtype,SOCK_STREAM,0);
		if (INVALID_SOCKET == s1)
			goto error;
		nStatus = connect(s1,(PSOCKADDR)&aAddress,sizeof(SOCKADDR_IN));
		if (SOCKET_ERROR == nStatus)
			goto error;
		sSocket[i] = s1;
		setsockopt(sSocket[i],IPPROTO_TCP,TCP_NODELAY,(char*)&enable,sizeof(int));
		nStatus = SendSocketN(sSocket[i],(BYTE*)&dwMyID,sizeof(int));
		if (SOCKET_ERROR == nStatus)
			goto error;
		printf("Connected to machine [%d]\n",i);
	}
cleanup:
	return wsaInit;
error:
	*status = WSAGetLastError();
	if (wsaInit)
	{
		WSACleanup();
		wsaInit = FALSE;
	}
	goto cleanup;
}
