#include "windows.h"
#include "dm.h"
#include "packets.h"
#include "queue.h"
#include "queuedata.h"
#include "stdio.h"
#include "tchar.h"
#include "winsock.h"
#include "sockutil.h"
#include "mpitcpproc.h"
#include "crtdbg.h"

WINMPICHAPI WORLDPROCESSMAP *WorldProcessMap;
BOOL fReceiveInProgress = FALSE;


DWORD WINAPI TCPIPReceiveThread(LPVOID lpV)
{
	DWORD dwStatus = ERROR_SUCCESS;
	extern SOCKET *sSocket;
	MPID_PKT_T *pPkt = NULL;
	BYTE *pDataBuffer = NULL;
	DWORD dwBufferSize = 0;
	DWORD dwReadSize;
	int nBytesRead;
	extern DWORD dwNumMachines;
	extern DWORD dwMyID;
	int nNumToRead;
	LONG nSource;
	LONG nDestination;
	LONG nDest;

	DWORD i;
	fd_set ReadSet;

	while (TRUE)
	{
		FD_ZERO(&ReadSet);
		for (i=0;i < dwNumMachines;i++)
		{
			if (i != dwMyID)
			{
				FD_SET(sSocket[i],&ReadSet);
			}
		}
		fReceiveInProgress = FALSE;
		nNumToRead = select(dwNumMachines-1,&ReadSet,NULL,NULL,NULL);
		fReceiveInProgress = TRUE;
		if (SOCKET_ERROR == nNumToRead)
		{
			dwStatus = WSAGetLastError();
			goto cleanup;
		}
		for (i=0;i < dwNumMachines;i++)
		{
			if (FD_ISSET(sSocket[i],&ReadSet))
			{
				dwStatus = AllocateQueuePacket(&pPkt);
				if (ERROR_SUCCESS != dwStatus)
				{
					goto cleanup;
				}
				dwReadSize = sizeof(MPID_PKT_MODE_T);
				nBytesRead = RecvSocketN(sSocket[i],
										 (BYTE*)pPkt,
										 dwReadSize);
				if (SOCKET_ERROR == nBytesRead)
				{
					dwStatus = WSAGetLastError();
					goto cleanup;
				}
				{
					BYTE *pBuffer = NULL;
					switch (pPkt->head.mode)
					{
					case MPID_PKT_SHORT_SYNC:
						dwReadSize =  sizeof(MPID_PKT_HEAD_T)
									- sizeof(MPID_PKT_MODE_T)
									+ sizeof(MPID_Aint);
						nBytesRead = RecvSocketN(sSocket[i],
												 (BYTE*)&(pPkt->short_sync_pkt.context_id),
												 dwReadSize);
						if (SOCKET_ERROR == nBytesRead)
						{
							dwStatus = WSAGetLastError();
							goto cleanup;
						}
						dwReadSize = pPkt->head.len;
						nBytesRead = RecvSocketN(sSocket[i],
												 (BYTE*)(pPkt->short_sync_pkt.buffer),
												 dwReadSize);
						break;
					case MPID_PKT_SHORT:
						dwReadSize =  sizeof(MPID_PKT_HEAD_T)
									- sizeof(MPID_PKT_MODE_T);
						nBytesRead = RecvSocketN(sSocket[i],
												 (BYTE*)&(pPkt->head.context_id),
												 dwReadSize);
						if (SOCKET_ERROR == nBytesRead)
						{
							dwStatus = WSAGetLastError();
							goto cleanup;
						}
						dwReadSize = pPkt->head.len;
						nBytesRead = RecvSocketN(sSocket[i],
												 (BYTE*)(pPkt->short_pkt.buffer),
												 dwReadSize);
						break;
					case MPID_PKT_SYNC_ACK:
						dwReadSize = sizeof(MPID_Aint);
						nBytesRead = RecvSocketN(sSocket[i],
												 (BYTE*)&(pPkt->sync_ack_pkt.sync_id),
												 dwReadSize);
						break;
					case MPID_PKT_LONG:
						dwReadSize =  sizeof(MPID_PKT_LONG_T)
									- sizeof(MPID_PKT_MODE_T);
						nBytesRead = RecvSocketN(sSocket[i],
												 (BYTE*)&(pPkt->long_pkt.context_id),
												 dwReadSize);
						if (SOCKET_ERROR == nBytesRead)
						{
							dwStatus = WSAGetLastError();
							goto cleanup;
						}
						dwReadSize = pPkt->head.len;
						pDataBuffer = (BYTE*)malloc(dwReadSize);
						if (0 == pDataBuffer)
						{
							dwStatus = GetLastError();
							goto cleanup;
						}
						nBytesRead = RecvSocketN(sSocket[i],
												 pDataBuffer,
												 dwReadSize);
						pPkt->long_pkt.pBuffer = pDataBuffer;
						break;
					case MPID_PKT_LONG_SYNC:
						dwReadSize =  sizeof(MPID_PKT_LONG_SYNC_T)
									- sizeof(MPID_PKT_MODE_T)
									+ sizeof(MPID_Aint);
						nBytesRead = RecvSocketN(sSocket[i],
												 (BYTE*)&(pPkt->long_sync_pkt.context_id),
												 dwReadSize);
						if (SOCKET_ERROR == nBytesRead)
						{
							dwStatus = WSAGetLastError();
							goto cleanup;
						}
						dwReadSize = pPkt->head.len;
						dwStatus = AllocateQueueBuffer(&pDataBuffer,dwReadSize);
						pDataBuffer = (BYTE*)malloc(dwReadSize);
						if (0 == pDataBuffer)
						{
							dwStatus = GetLastError();
							goto cleanup;
						}
						nBytesRead = RecvSocketN(sSocket[i],
												 pDataBuffer,
												 dwReadSize);
						pPkt->long_sync_pkt.pBuffer = pDataBuffer;
						break;
					}
					if (SOCKET_ERROR == nBytesRead)
					{
						dwStatus = WSAGetLastError();
						goto cleanup;
					}
					nDestination = pPkt->head.dest;
					nDest = WorldProcessMap->Process[nDestination].dwLocalBufferNumber;
					nSource = pPkt->head.src;
					Enqueue(SENDQUEUE,pPkt,nSource,&dwStatus);
				}			
			}
		}
	}

cleanup:
	fReceiveInProgress = FALSE;
	for (i=0;i<dwNumMachines;i++)
		closesocket(sSocket[i]);
	return dwStatus;
}