#include "windows.h"
#include "dm.h"
#include "packets.h"
#include "queue.h"
#include "queuedata.h"
#include "stdio.h"
#include "tchar.h"
#include "winsock.h"
#include "sockutil.h"
#include "mpitcpproc.h"
#include "crtdbg.h"

WINMPICHAPI WORLDPROCESSMAP *WorldProcessMap;

DWORD WINAPI TCPIPSendThread(LPVOID lpV)
{
	DWORD dwStatus = ERROR_SUCCESS;
	extern SOCKET *sSocket;
	extern QUEUETYPE Queue[];
	extern DWORD dwNumMachines;
	MPID_PKT_T *pPkt=NULL;
	DWORD dwBufferSize = 0;
	int nBytesSent;
	DWORD dwTargetMachine;
	DWORD dwSendSize;
	HANDLE hEvents[2];
	int nSource;
	int nDest;
	BOOL fStatus;

	hEvents[0] = hEndProcessEvent;
	hEvents[1] = Queue[RECEIVEQUEUE].hSomethingQueued;

	while (TRUE)
	{
		dwStatus = WaitForMultipleObjects(2,hEvents,FALSE,INFINITE);
		if (WAIT_FAILED == dwStatus)
		{
			dwStatus = GetLastError();
			_ASSERTE(FALSE);
			goto cleanup;
		}
		if (WAIT_OBJECT_0 == dwStatus)
			goto cleanup;

		fStatus = Dequeue(RECEIVEQUEUE,&pPkt,&nSource,&dwStatus);

		{
			FILE *pDF=NULL;
			pDF = fopen("sendthread.txt","w+");
			if (pDF)
			{
				fprintf(pDF,"pkt\n");
				fprintf(pDF,"\tmode\t%x\n",pPkt->head.mode);
				fprintf(pDF,"\tsrc\t%x\n",pPkt->head.src);
				fprintf(pDF,"\tctx\t%x\n",pPkt->head.context_id);
				fprintf(pDF,"\tlrank\t%x\n",pPkt->head.lrank);
				fprintf(pDF,"\tag\t%x\n",pPkt->head.tag);
				fprintf(pDF,"\tlen\t%x\n",pPkt->head.len);
				fprintf(pDF,"\tdest\t%x\n",pPkt->head.dest);
				fflush(pDF);
				fclose(pDF);
			}
		}

		nDest = pPkt->head.dest;
		_ASSERTE((0 <= nDest) && (nDest < WorldProcessMap->dwNumProcs));
		dwTargetMachine = WorldProcessMap->Process[nDest].dwMachineNumber;
		if (!fStatus)
			goto cleanup;

		dwSendSize = sizeof(MPID_PKT_MODE_T);
		nBytesSent = SendSocketN(sSocket[dwTargetMachine],(BYTE*)pPkt,dwSendSize);
		if (SOCKET_ERROR == nBytesSent)
		{
			dwStatus = WSAGetLastError();
			goto cleanup;
		}
		switch (pPkt->head.mode)
		{
		case MPID_PKT_SYNC_ACK:
			dwSendSize = sizeof(MPID_Aint);
			nBytesSent = SendSocketN(sSocket[dwTargetMachine],
									 (BYTE*)&(pPkt->sync_ack_pkt.sync_id),
									 dwSendSize);
			break;
		case MPID_PKT_SHORT:
			dwSendSize =  sizeof(MPID_PKT_HEAD_T) 
						- sizeof(MPID_PKT_MODE_T)
						+ pPkt->head.len;
			nBytesSent = SendSocketN(sSocket[dwTargetMachine],
									 (BYTE*)&(pPkt->head.context_id),
									 dwSendSize);
			break;
		case MPID_PKT_SHORT_SYNC:
			dwSendSize =  sizeof(MPID_PKT_HEAD_T)
						- sizeof(MPID_PKT_MODE_T)
						+ sizeof(MPID_Aint)
						+ pPkt->head.len ;
			nBytesSent = SendSocketN(sSocket[dwTargetMachine],
									 (BYTE*)&(pPkt->head.context_id),
									 dwSendSize);
			break;
		case MPID_PKT_LONG_SYNC:
			dwSendSize =  sizeof(MPID_PKT_LONG_SYNC_T)
						- sizeof(MPID_PKT_MODE_T)
						+ sizeof(MPID_Aint);
			nBytesSent = SendSocketN(sSocket[dwTargetMachine],
									 (BYTE*)&(pPkt->head.context_id),
									 dwSendSize);
			if (SOCKET_ERROR == nBytesSent)
			{
				dwStatus = WSAGetLastError();
				goto cleanup;
			}
			dwSendSize = pPkt->head.len;
			nBytesSent = SendSocketN(sSocket[dwTargetMachine],
									 (BYTE*)pPkt->long_sync_pkt.pBuffer,
									 dwSendSize);
			if (SOCKET_ERROR == nBytesSent)
			{
				dwStatus = WSAGetLastError();
				goto cleanup;
			}
			if (pPkt->long_sync_pkt.pBuffer)
				FreeQueueBuffer(pPkt->long_sync_pkt.pBuffer);
			break;
		case MPID_PKT_LONG:
			dwSendSize =  sizeof(MPID_PKT_LONG_T)
						- sizeof(MPID_PKT_MODE_T);
			nBytesSent = SendSocketN(sSocket[dwTargetMachine],
									 (BYTE*)&(pPkt->head.context_id),
									 dwSendSize);
			if (SOCKET_ERROR == nBytesSent)
			{
				dwStatus = WSAGetLastError();
				goto cleanup;
			}
			dwSendSize = pPkt->head.len;
			nBytesSent = SendSocketN(sSocket[dwTargetMachine],
									 (BYTE*)pPkt->long_pkt.pBuffer,
									 dwSendSize);
			if (SOCKET_ERROR == nBytesSent)
			{
				dwStatus = WSAGetLastError();
				goto cleanup;
			}
			if (pPkt->long_pkt.pBuffer)
				free(pPkt->long_pkt.pBuffer);
			break;
		default:
			break;
		}
		FreeQueuePacket(pPkt);
		pPkt = NULL;
	}
cleanup:
	return dwStatus;
}
